;  Based on yOda kernel.zip
;  See more about WHILE - ENDWHILE || REPEAT - BREAK - UNTIL at:
;  http://www.masm32.com/board/index.php?topic=8859.0


.386
.model flat,stdcall
option casemap:none

;INCLUDE    \masm32\include\windows.inc

INCLUDE    \masm32\include\comdlg32.inc ; for GetOpenFileName
INCLUDELIB \masm32\lib\comdlg32.lib

; ------ STRUCTS ------
sSEH STRUCT
	OrgEsp		  dd ?
	OrgEbp		  dd ?
	SaveEip 	  dd ?
sSEH ENDS

; ------ EQU'S ------
MIN_KERNEL_SEARCH_BASE	  EQU 070000000h
MAX_API_STRING_LENGTH	  EQU 150


IMAGE_EXPORT_DIRECTORY STRUCT
  Characteristics           DWORD      ?
  TimeDateStamp             DWORD      ?
  MajorVersion              WORD       ?
  MinorVersion              WORD       ?
  nName                     DWORD      ?
  nBase                     DWORD      ?
  NumberOfFunctions         DWORD      ?
  NumberOfNames             DWORD      ?
  AddressOfFunctions        DWORD      ?
  AddressOfNames            DWORD      ?
  AddressOfNameOrdinals     DWORD      ?
IMAGE_EXPORT_DIRECTORY ENDS


; ------ CONST ------
.CONST
szLoadLibrary	    db	 "LoadLibraryA",0
szGetVersionExA 	 db  "GetVersionExA",0
szGetProcAddress	 db  "GetProcAddress",0

szExitProcess	    db	 "ExitProcess",0

szUser32		  db   "user32",0
szMessageBox	    db	 "MessageBoxA",0
szwsprintf		  db   "wsprintfA",0

szInfoCap		  db   "- Kernel -",0
szInfoText		  db   "The following information were obtained",13,10
			  db   "without the help of an Import Table !",13,10
			  db  13,10
			  db   "Kernel32.dll ImageBase:  0x%08lX",13,10
			  db   "User32.dll ImageBase:  0x%08lX",13,10
			  db  13,10
			  db   "API Addresses:",13,10
			  db   "LoadLibraryA:  0x%08lX",13,10
			  db   "GetProcAddress:  0x%08lX",13,10
			  db   "ExitProcess:  0x%08lX",13,10
			  db  13,10
			  db   "MessageBoxA:  0x%08lX",13,10
			  db   "wsprintfA:  0x%08lX",0

; ------ DATA ------
.DATA

_LoadLibrary	    dd 0
_GetProcAddress 	  dd 0
_ExitProcess	    dd 0
_MessageBox		  dd 0
_wsprintf		  dd 0

cBuff			  db 200 DUP (0)
SEH			  sSEH <0>

dwKernelBase	    dd 0
dwUserBase		  dd 0

; ------ CODE ------
.CODE
main:
	;;ASSUME FS : NOTHING
	
	;INT 3
	
	;---- GET ImageBase of kernel32.dll ----        

	xor eax, eax
	mov eax, esp	; PUSH dword ptr [ESP]

	;PUSH [ESP]
	CALL GetKernelBase
	OR   EAX, EAX
	JZ   QUIT
	MOV  dwKernelBase, EAX
	
	;---- GET SOME KERNEL API ADDRESSES ----
	;-> LoadLibraryA
	PUSH OFFSET szLoadLibrary
	PUSH dwKernelBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _LoadLibrary, EAX
	
	;-> GetProcAddress
	PUSH OFFSET szGetProcAddress
	PUSH dwKernelBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _GetProcAddress, EAX
	
	;-> ExitProcess
	PUSH OFFSET szExitProcess
	PUSH dwKernelBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _ExitProcess, EAX
	
	;---- LOAD USER32.DLL ----
	PUSH OFFSET szUser32
	CALL _LoadLibrary
	OR   EAX, EAX
	JZ   QUIT
	MOV  dwUserBase, EAX
	
	;---- GET SOME USER API ADDRESSES ----
	;-> MessageBoxA
	PUSH OFFSET szMessageBox
	PUSH dwUserBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _MessageBox, EAX
	
	;-> wsprintfA
	PUSH OFFSET szwsprintf
	PUSH dwUserBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _wsprintf, EAX
	
	;---- BUILD AND SHOW THE INFORMATION MSG ----
	PUSH _wsprintf
	PUSH _MessageBox
	PUSH _ExitProcess
	PUSH _GetProcAddress
	PUSH _LoadLibrary
	PUSH dwUserBase
	PUSH dwKernelBase
	
	PUSH OFFSET szInfoText
	PUSH OFFSET cBuff
	CALL _wsprintf
 ;;;  ADD  ESP, (9 * SIZEOF(DWORD))   ; don't work for POASM 
	
	PUSH 0
	PUSH 0
	PUSH OFFSET cBuff
	PUSH 0
	CALL _MessageBox
	
	;---- EXIT ----
	CALL _ExitProcess			  ;)

QUIT:
	RET					    ; exit to OS
	
;---- AN UNUSED IMPORT ----------------------
					    ;  The Win32 Loader of Win2k (maybe also
					    ;  WinNT) won't call EntryPoint of files
					    ;  which don't have an Import Table :(
					    ;  Here a unused Import to make MASM
					    ;  compile an Import Table.

			    PUSH 0
			    CALL GetOpenFileName
	
; ##############################################
; ##############################################
GetProcAddr PROC dwDllBase :DWORD, szApi :DWORD

push EDX
push EBX
push ECX
push EDI
push ESI

      MOV    ESI, dwDllBase              ;  check PE Signarue
	CMP    WORD PTR [ESI], 5a4dh       ;  IMAGE_DOS_SIGNATURE
	JNZ @@_BadExit
	ADD    ESI, [ESI+03Ch]
	CMP    DWORD PTR [ESI], 4550h      ;  IMAGE_NT_SIGNATURE
	JNZ @@_BadExit
;..............................................................
	MOV  EDI, [szApi]			     ;  get str len of Api
	MOV  ECX, MAX_API_STRING_LENGTH
	XOR  AL, AL
	REPNZ  SCASB
	MOV  ECX, EDI
	SUB  ECX, [szApi]			     ;  ECX -> Api str len
;..............................................................
	MOV  EDX, [ESI+078h]	  ; trace the export table
	ADD  EDX, dwDllBase	  ; EDX -> Export table

mov ebx, [edx+IMAGE_EXPORT_DIRECTORY.AddressOfNames] ;  EBX -> A.o.N array pointer
	ADD  EBX, dwDllBase
	XOR  EAX, EAX				           ;  EAX AddressOfNames Index

;.....................................................  EAX Free
;.....................................................
;.....................................................  REPEAT - BREAK - UNTIL
_b_REPETE:

        MOV  EDI, [EBX]
        ADD  EDI, dwDllBase
        MOV  ESI, [szApi]  ;  szApi
        PUSH ECX           ;  number of char to cmp.  save api string length for
                           ;  next time through loop
        REPZ CMPSB         ;  look for difference between strings
        POP  ECX           ;  get back number of characters to check (and fix stack)
        jz  _b_UNTIL       ; .BREAK .IF ZERO? 
        ADD  EBX, 4
        INC  EAX       
        cmp  eax, [edx+IMAGE_EXPORT_DIRECTORY.AddressOfNames]

 jne _b_REPETE
            _b_UNTIL:
;................................................................   find 
;................................................................   corresponding
;................................................................   Ordinal
_empty:
	MOV  ESI, [edx+IMAGE_EXPORT_DIRECTORY.AddressOfNameOrdinals]

	ADD  ESI, dwDllBase
	PUSH EDX			; save the export table pointer
	MOV  EBX, 2
	XOR  EDX, EDX
	MUL  EBX
	POP  EDX
	ADD  EAX, ESI
	XOR  ECX, ECX
;	MOV  WORD PTR CX, [EAX]     ;  ECX -> Api Ordinal
	MOV  CX, WORD PTR [EAX]     ;  for POASM and MASM
;.........................................................  get address of api
 MOV  EDI, [edx+IMAGE_EXPORT_DIRECTORY.AddressOfFunctions]
	
	XOR  EDX, EDX
	MOV  EBX, 4
	MOV  EAX, ECX
	MUL  EBX
	ADD  EAX, dwDllBase
	ADD  EAX, EDI
	MOV  EAX, [EAX]
	ADD  EAX, dwDllBase
   JMP  @@_ExitProc
	
@@_BadExit:
                XOR  EAX, EAX	
@@_ExitProc:
                ; shutdown SEH frame
                ;POP  FS:[0]
                ;ADD  ESP, 4
pop ESI
pop EDI
pop ECX
pop EBX
pop EDX

	RET
GetProcAddr ENDP

; ######################################################
; ######################################################
; ######################################################
;.....................................................
GetKernelBase PROC dwTopStack :DWORD

push ESI
push EDI

   MOV  EDI, dwTopStack             ;  start the search
   AND  EDI, 0FFFF0000h             ;  wipe the LOWORD !
;  .....................................................    WHILE - ENDWHILE
_a_WHILE:
                    mov  ESI, EDI
                    add  ESI, [ESI+03Ch]
                    cmp  dword ptr [esi], 4550h        ;    IMAGE_NT_SIGNATURE
   je _a_ENDWHILE
;  .....................................................
   SUB EDI, 010000h
		        cmp EDI, 070000000h                ;    MIN_KERNEL_SEARCH_BASE
   jnb _a_ENDWHILE                                     ;    jnb = if not below !!!
		        mov EDI, 0BFF70000h
   jmp _a_WHILE                                        ;  - BREAK BUT
; ......................................................

_a_ENDWHILE:
   XCHG eax, EDI

pop EDI
pop ESI

   RET
GetKernelBase ENDP

end main